zoukankan      html  css  js  c++  java
  • LeetCode #292. Nim Game

    Nim Game

    题目描述:

    You are playing the following Nim Game with your friend: There is a heap of stones on the table, each time one of you take turns to remove 1 to 3 stones. The one who removes the last stone will be the winner. You will take the first turn to remove the stones.

    Both of you are very clever and have optimal strategies for the game. Write a function to determine whether you can win the game given the number of stones in the heap.

    For example, if there are 4 stones in the heap, then you will never win the game: no matter 1, 2, or 3 stones you remove, the last stone will always be removed by your friend.

    Hint:

    If there are 5 stones in the heap, could you figure out a way to remove the stones such that you will always be the winner?

    题目大意:

    你正在和朋友玩下面的Nim游戏:桌子上有一堆石头,每一次你们轮流取1至3颗石头。最后一个取走石头的人就是赢家。第一轮由你先取。

    你们俩都很聪明并且掌握玩游戏的最佳策略。编写函数,给定石头的个数,判断你是否可以赢得游戏。

    例如,如果堆中有4颗石头,那么你一定不会赢得游戏:无论你第一轮取走1,2,还是3颗石头,下一轮你的朋友都可以取走余下的所有石头。

    提示:

    如果堆中有5颗石头,你可以找出确保自己能赢的取石子策略吗?

    解题思路:

    当n∈[1,3]时,先手必胜。

    当n==4时,无论第一轮取得1至3中几颗石头,都会导致第二轮重复n∈[1,3]的情况,所以此时必负。

    当n∈[5,7]时,通过分别取走[1,3]颗石头,使第二轮情况转化为n==4,此时先手必胜,后手必负。

    当n==8时,无论第一轮取得1至3中几颗石头,都会导致第二轮重复n∈[5,7]的情况,所以此时先手必负。

    ...

    可得出结论:

    当 n%4 !=0 时,先手必胜;否则先手必负。

    C++代码:

     1 class Solution {
     2 
     3     public:
     4 
     5         bool canWinNim(int n) {
     6 
     7         return n % 4 != 0;
     8 
     9         }
    10 
    11 };
  • 相关阅读:
    ZOJ 3529
    将博客搬至CSDN
    BST 增删查操作 递归/非递归实现
    容器vector容量翻倍增长策略效率分析
    整数分解为若干项之和
    PAT-B-1080 MOOC期终成绩
    最大公约数 + 最小公倍数
    Fibonacci数
    排序
    PAT-B-1020
  • 原文地址:https://www.cnblogs.com/nemowang1996/p/6534492.html
Copyright © 2011-2022 走看看